# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from featurenav_base/Segment.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import geometry_msgs.msg
import featurenav_base.msg

class Segment(genpy.Message):
  _md5sum = "907df4c58fa11e2d97e8b143c205816c"
  _type = "featurenav_base/Segment"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """float64 yaw
float64 distance
Landmark[] landmarks

================================================================================
MSG: featurenav_base/Landmark
# Feature descriptors.
Feature descriptor

# Position of feature in the image when first detected.
geometry_msgs/Point u

# Position of feature in the image when last detected.
geometry_msgs/Point v

# Distance from segment start associated to u.
float64 du

# Distance from segment start associated to v.
float64 dv

================================================================================
MSG: featurenav_base/Feature
# Implementation-dependent feature descriptor.

uint64[] udata
int64[] idata
float64[] fdata

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z
"""
  __slots__ = ['yaw','distance','landmarks']
  _slot_types = ['float64','float64','featurenav_base/Landmark[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       yaw,distance,landmarks

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Segment, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.yaw is None:
        self.yaw = 0.
      if self.distance is None:
        self.distance = 0.
      if self.landmarks is None:
        self.landmarks = []
    else:
      self.yaw = 0.
      self.distance = 0.
      self.landmarks = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_2d.pack(_x.yaw, _x.distance))
      length = len(self.landmarks)
      buff.write(_struct_I.pack(length))
      for val1 in self.landmarks:
        _v1 = val1.descriptor
        length = len(_v1.udata)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(struct.pack(pattern, *_v1.udata))
        length = len(_v1.idata)
        buff.write(_struct_I.pack(length))
        pattern = '<%sq'%length
        buff.write(struct.pack(pattern, *_v1.idata))
        length = len(_v1.fdata)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(struct.pack(pattern, *_v1.fdata))
        _v2 = val1.u
        _x = _v2
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v3 = val1.v
        _x = _v3
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_struct_2d.pack(_x.du, _x.dv))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.landmarks is None:
        self.landmarks = None
      end = 0
      _x = self
      start = end
      end += 16
      (_x.yaw, _x.distance,) = _struct_2d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.landmarks = []
      for i in range(0, length):
        val1 = featurenav_base.msg.Landmark()
        _v4 = val1.descriptor
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        end += struct.calcsize(pattern)
        _v4.udata = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sq'%length
        start = end
        end += struct.calcsize(pattern)
        _v4.idata = struct.unpack(pattern, str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v4.fdata = struct.unpack(pattern, str[start:end])
        _v5 = val1.u
        _x = _v5
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v6 = val1.v
        _x = _v6
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.du, _x.dv,) = _struct_2d.unpack(str[start:end])
        self.landmarks.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_2d.pack(_x.yaw, _x.distance))
      length = len(self.landmarks)
      buff.write(_struct_I.pack(length))
      for val1 in self.landmarks:
        _v7 = val1.descriptor
        length = len(_v7.udata)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(_v7.udata.tostring())
        length = len(_v7.idata)
        buff.write(_struct_I.pack(length))
        pattern = '<%sq'%length
        buff.write(_v7.idata.tostring())
        length = len(_v7.fdata)
        buff.write(_struct_I.pack(length))
        pattern = '<%sd'%length
        buff.write(_v7.fdata.tostring())
        _v8 = val1.u
        _x = _v8
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _v9 = val1.v
        _x = _v9
        buff.write(_struct_3d.pack(_x.x, _x.y, _x.z))
        _x = val1
        buff.write(_struct_2d.pack(_x.du, _x.dv))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.landmarks is None:
        self.landmarks = None
      end = 0
      _x = self
      start = end
      end += 16
      (_x.yaw, _x.distance,) = _struct_2d.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.landmarks = []
      for i in range(0, length):
        val1 = featurenav_base.msg.Landmark()
        _v10 = val1.descriptor
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        end += struct.calcsize(pattern)
        _v10.udata = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sq'%length
        start = end
        end += struct.calcsize(pattern)
        _v10.idata = numpy.frombuffer(str[start:end], dtype=numpy.int64, count=length)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sd'%length
        start = end
        end += struct.calcsize(pattern)
        _v10.fdata = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
        _v11 = val1.u
        _x = _v11
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _v12 = val1.v
        _x = _v12
        start = end
        end += 24
        (_x.x, _x.y, _x.z,) = _struct_3d.unpack(str[start:end])
        _x = val1
        start = end
        end += 16
        (_x.du, _x.dv,) = _struct_2d.unpack(str[start:end])
        self.landmarks.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_2d = struct.Struct("<2d")
_struct_3d = struct.Struct("<3d")
